package com.ff.weijinxiao.service;


import com.ff.weijinxiao.domain.MemberPackage;
import com.ff.weijinxiao.repository.MemberPackageRepository;
import com.ff.weijinxiao.util.SpecificationUtil;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.Optional;

@Service
public class MemberPackageService {

    @Resource
    private MemberPackageRepository memberPackageRepository;

    /**
     * 创建实体
     *
     * @param memberPackage
     */
    public MemberPackage saveMemberPackage(MemberPackage memberPackage) {
        return memberPackageRepository.save(memberPackage);
    }

    /**
     * 查找实体
     *
     * @param id
     * @return
     */
    public MemberPackage findById(Integer id) {
        Optional<MemberPackage> optional = memberPackageRepository.findById(id);
        if (optional.isPresent()) {
            return optional.get();
        } else {
            return null;
        }
    }

    public void deleteById(Integer id) {
        memberPackageRepository.deleteById(id);
    }

    /**
     * 分页条件查询
     *
     * @param page
     * @param size
     * @param param
     * @return
     */
    public Page<MemberPackage> findPage(int page, int size, Map<String, Object> param) {
        Sort.Direction direction = Sort.Direction.DESC;
        String sort = "id";
        Pageable pageable = new PageRequest(page - 1, size, direction, sort);
        return memberPackageRepository.findAll(SpecificationUtil.buildSpecification(param, MemberPackage.class), pageable);
    }

    /**
     * 根据条件查询List
     */
    public List<MemberPackage> findList(Map<String, Object> param) {
        return memberPackageRepository.findAll(SpecificationUtil.buildSpecification(param, MemberPackage.class));
    }

}
